<?php
	/*************************************************************************************************************************************
	This product was originally created by Matt Berntsen in October of 2005.
	I can be reached at <http://www.MattBerntsen.net>.
	It is licensed by the OSL v2.1 available in the included license.txt file and at <http://opensource.org/licenses/osl-2.1.php>.
	*************************************************************************************************************************************/

session_start();
include_once("config.php");

/***************************************************************************
						Public Functions
***************************************************************************/

// Pre: inTime as a vlaid integer, and inMsg and inTarget are valid strings.
// Post: Generates code to wait inTime seconds, then redirect to Target. Displays inMsg w/ a link in case brower does not auto-redirect.
function redirect($inTime, $inMsg, $inTarget){
	// Input Validation
	if(gettype($inTarget) != 'string' || strlen($inTarget) == 0)
		return '';
	if(gettype($inTime)!= 'integer' || $inTime < 0)
		$inTime = 0;
		
	$rtn = '<meta http-equiv="REFRESH" content="'.$inTime.';url='.$inTarget.'"></HEAD><BODY>';	
	if(gettype($inMsg) == 'string')
		$rtn = $rtn.'<p>'.$inMsg.'</p>';
	return $rtn.'<p>You will be automatically redirected in '.$inTime.' seconds. If you are not, please click <a href="'.$inTarget.'">here</a>.</p>';
}


/***************************************************************************
				Private Functions | DO NOT USE OR MODIFY
***************************************************************************/

// Pre: Connection to database has been established.
// Post: return true if specified user credientials are correct, and log them in. Otherwise return false.
function verify(){
	global $CONFIG;
	$urn = strtolower($_POST["username"]);
	$resource = mysql_query("SELECT user_login FROM ".$CONFIG['prefix']."User WHERE user_login='".$urn."' 
		AND user_MD5='".md5($_POST["password"].$CONFIG['salt'])."' AND user_SHA1='".sha1($_POST["password"].$CONFIG['salt'])."'");
	if($resource != false && mysql_num_rows($resource) > 0){
		$_SESSION['user'] = $urn;
		if (getenv(HTTP_X_FORWARDED_FOR)){
	    $ip = getenv(HTTP_X_FORWARDED_FOR);
		} else {
	    $ip = getenv(REMOTE_ADDR);
		mysql_query('UPDATE '.$CONFIG['prefix'].'User SET user_active=1, user_last=NOW(), user_ip="'.$ip.'" WHERE user_login="'.$urn.'"');
		}	
		return true;
	}else
		return false;
}

// Pre: Connection to database has been established.
// Post: Adds user with the appropriate credentials if a user with the same username (login) does not already exist.
function add_user($in_urn, $in_display, $in_pass, $in_admin){
	global $CONFIG;
	if(gettype($in_urn) == "string" && gettype($in_display) == "string" && gettype($in_pass) == "string" && gettype($in_admin) == "boolean"){
		$resource = mysql_query("SELECT user_login FROM ".$CONFIG['prefix']."User WHERE user_login=\"".strtolower($in_urn)."\";");
		if(!$resource)
			return false;
		if(mysql_num_rows($resource) == 0){
			if($in_admin)
				$in_admin = 1;
			else
				$in_admin = 0;
			mysql_query("INSERT INTO ".$CONFIG['prefix']."User (user_login, user_MD5, user_SHA1, user_display, user_admin, user_enabled, user_active, user_last)
			values (\"".strtolower($in_urn)."\", \"".md5($in_pass.$CONFIG['salt'])."\", \"".sha1($in_pass.$CONFIG['salt'])."\", \"".$in_display."\", ".$in_admin.", 1, 0, NOW());");
			return true;
		}
	}
	return false;
}

// Pre: None
// Post: connects to server if possible, or displays applicable error message.
function db_connect()
{
	global $CONFIG;
	$result = mysql_connect($CONFIG['dbserver'], $CONFIG['dbuser'], $CONFIG['dbpass']);
	if (!$result || !mysql_select_db($CONFIG['dbname']))
		die("</HEAD><BODY><b>SMBS critical error</b>:<br>Unable to connect to database<br><br>MySQL said: <b>".mysql_error()."</b>");
	return $result;
}

// Pre:  Connection to database has been established.
// Post: Returns 0 if logged out, 1 if standard user, 2 if admin.
function get_status(){
	global $CONFIG;
	session_start();
	if (getenv(HTTP_X_FORWARDED_FOR))
    	$ip = getenv(HTTP_X_FORWARDED_FOR);
	else{
    	$ip = getenv(REMOTE_ADDR);
	}
	$tmp_usr = strtolower($_SESSION[user]);
	$resource = mysql_query("SELECT user_admin FROM ".$CONFIG['prefix']."User WHERE user_login='".$tmp_usr."' 
		AND user_active=1 AND user_enabled=1 AND user_ip='".$ip."' AND user_last > (NOW()-900)");
	if($resource != false && mysql_num_rows($resource) > 0){
		mysql_query('UPDATE '.$CONFIG['prefix'].'User SET user_last=NOW() WHERE user_login="'.$tmp_usr.'"');
		$row = mysql_fetch_row($resource);
		if($row[0]==1)
			return 2;
		else
			return 1;
	}else
		return 0;
}
?>